//
// Generated file, do not edit! Created by nedtool 4.6 from tree.msg.
//

#ifndef _TREE_M_H_
#define _TREE_M_H_

#include <omnetpp.h>

// nedtool version check
#define MSGC_VERSION 0x0406
#if (MSGC_VERSION!=OMNETPP_VERSION)
#    error Version mismatch! Probably this file was generated by an earlier version of nedtool: 'make clean' should help.
#endif



/**
 * Class generated from <tt>tree.msg:19</tt> by nedtool.
 * <pre>
 * //
 * // TODO generated message class
 * //
 * packet Tree
 * {
 *     string topic;
 *     bool broadcast = false;
 *     string type;
 *     int SourceID;
 *     int DestinationID;
 *     int Cost;
 * 
 *     //zigbee
 *     int Tx_power;
 * }
 * </pre>
 */
class Tree : public ::cPacket
{
  protected:
    opp_string topic_var;
    bool broadcast_var;
    opp_string type_var;
    int SourceID_var;
    int DestinationID_var;
    int Cost_var;
    int Tx_power_var;

  private:
    void copy(const Tree& other);

  protected:
    // protected and unimplemented operator==(), to prevent accidental usage
    bool operator==(const Tree&);

  public:
    Tree(const char *name=NULL, int kind=0);
    Tree(const Tree& other);
    virtual ~Tree();
    Tree& operator=(const Tree& other);
    virtual Tree *dup() const {return new Tree(*this);}
    virtual void parsimPack(cCommBuffer *b);
    virtual void parsimUnpack(cCommBuffer *b);

    // field getter/setter methods
    virtual const char * getTopic() const;
    virtual void setTopic(const char * topic);
    virtual bool getBroadcast() const;
    virtual void setBroadcast(bool broadcast);
    virtual const char * getType() const;
    virtual void setType(const char * type);
    virtual int getSourceID() const;
    virtual void setSourceID(int SourceID);
    virtual int getDestinationID() const;
    virtual void setDestinationID(int DestinationID);
    virtual int getCost() const;
    virtual void setCost(int Cost);
    virtual int getTx_power() const;
    virtual void setTx_power(int Tx_power);
};

inline void doPacking(cCommBuffer *b, Tree& obj) {obj.parsimPack(b);}
inline void doUnpacking(cCommBuffer *b, Tree& obj) {obj.parsimUnpack(b);}


#endif // ifndef _TREE_M_H_

